

############################## NORMALLY DONT TOUCH ANYTHING BELOW ###########################

LD = $(PREFIX)g++
AS = $(PREFIX)gcc
CC = $(PREFIX)gcc
CXX = $(PREFIX)g++
AR = $(PREFIX)ar
OBJCOPY = $(PREFIX)objcopy
OBJDUMP = $(PREFIX)objdump

# Implicit rules

$(OBJDIR)%.o : $(SRCDIR)%.c
	$(CC) -c $(CFLAGS) $< -o $@

$(OBJDIR)%.o : $(SRCDIR)%.cpp
	$(CXX) -c $(CFLAGS) $< -o $@

$(OBJDIR)%.o : $(SRCDIR)%.cc
	$(CXX) -c $(CFLAGS) $< -o $@

$(OBJDIR)%.o : $(SRCDIR)%.S
	$(AS) $(ASFLAGS) $< -o $@

$(OBJDIR)%.o : $(SRCDIR)%.s
	$(AS) $(ASFLAGS) $< -o $@
	
$(OBJDIR)% :
	mkdir -p $@
	
CFLAGS += $(addprefix -I,$(MODULES))

MODULEOBJS = $(patsubst %.cpp,%.o, $(wildcard $(addsuffix /*.cpp,$(MODULES))))
MODULEOBJS += $(patsubst %.c,%.o, $(wildcard $(addsuffix /*.c,$(MODULES))))

OBJFILES = $(addprefix $(OBJDIR),$(OBJS) $(MODULEOBJS))
OBJDIRS = $(OBJDIR) $(addprefix $(OBJDIR), $(MODULES))

#all : $(OBJDIRS) $(OBJFILES) $(TARGET)$(EXT) 


$(OBJDIR) :
	mkdir -p $(OBJDIR)

%.nds.gba : %.nds
	dsbuild $< $@ 

%.nds :  %.bin
	gbfs data.gbfs data/*
	insgbfs data.gbfs $< gbfs_space
	ndstool -7 arm7.bin -9 $< -c $@

%.bin: %.elf
	$(OBJCOPY) -O binary $< $@

$(TARGET).a : $(OBJDIRS) $(OBJFILES) $(DEPS)
	$(AR) r $(TARGET).a $(OBJFILES)

$(TARGET).exe : $(OBJDIRS) $(OBJFILES) $(DEPS)
	$(LD) $(LDFLAGS) -o $(TARGET).exe $(OBJFILES) $(LIBS)
	cp $(TARGET).elf db_$(TARGET).exe
	$(PREFIX)strip $(TARGET).exe

$(TARGET).elf : $(OBJDIRS) $(OBJFILES) $(DEPS)
	$(LD) $(LDFLAGS) -o $(TARGET).elf $(OBJFILES) $(LIBS)
	cp $(TARGET).elf db_$(TARGET).elf
	$(PREFIX)strip $(TARGET).elf

	
clean :
	rm -rf $(OBJFILES) $(TARGET)$(EXT)

