
#ifdef POGO
#include <pogo/pogo.h>
#else
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <pogo/types.h>
#include <pogo/screen.h>
#include <pogo/font.h>

#include "util.h"

#ifdef _WIN32

DIR *opendir(char *name)
{
	char tmp[256];
	DIR *dir = (DIR*)malloc(sizeof(DIR));
	dir->de.d_name = NULL;
	sprintf(tmp, "%s/*", name);
	//printf("Looking for %s\n", tmp);
	dir->handle = _findfirst(tmp, &dir->fd);
	return dir;
}

struct dirent *readdir(DIR *dir)
{
	int rc = dir->handle;
	if(dir->de.d_name)
		rc = _findnext(dir->handle, &dir->fd);
	if(rc == -1)
		return NULL;
	dir->de.d_name = dir->fd.name;
	return &dir->de;
}

void closedir(DIR *dir)
{
	_findclose(dir->handle);
	free(dir);
}
#else

#include <dirent.h>

#endif

#endif

char *makeBaseName(char *name, char *dest)
{
	char *start, *end, *p;
	if((p = strrchr(name, '/')))
		start = p+1;
	else
		start = name;
		
	if((p = strrchr(name, '.')))
		end = p;
	else
		end = &name[strlen(name)];
	
	strncpy(dest, start, end-start);
	dest[end-start] = 0;
	return dest;
}

char *NextWord(char *ptr)
{
	while(*ptr && *ptr != ' ') ptr++;
	while(*ptr && *ptr == ' ') ptr++;
	return ptr;
}


// Parent dir where files are looked for
char basedir[128];
char *BASEDIR(char *dir)
{
	static char *endp = NULL;
	if(!endp)
		endp = &basedir[strlen(basedir)];
		
	if(*dir == '/')
		return dir;

	strcpy(endp, dir);
	return basedir;
}
