#ifndef POGOSCREEN_H
#define POGOSCREEN_H

#ifdef __cplusplus
extern "C" {
#endif

#include "platform.h"


int screen_setcolors(unsigned int *pal, int start, int size);
extern void (*screen_copy)(int x, int y, uchar *src, int width, int height, int sw, int solid);
extern void (*screen_set)(int x, int y, int width, int height, uint32 col);
extern Pixel* (*screen_pixel)(int x, int y);
extern void (*screen_scroll)(int x, int y, int width, int height, int lines);

void screen_line(int x0, int y0, int x1, int y1, uint32 col, int size);

void screen_set_target(Pixel *ptr, int hstride, int vstride);
void screen_set_rotation(int rotation);
void screen_get_target(Pixel **ptr, int *width, int *height, int *rotation);
void screen_init();
void screen_flush();

uint32 screen_color(int n);

enum {ROT_NOCHANGE, ROT_TOPLEFT, ROT_TOPRIGHT, ROT_BOTTOMRIGHT, ROT_BOTTOMLEFT};


#ifdef __cplusplus
}
#endif

#endif
