int vsprintf(char *dest, char *fmt, va_list vl)
{
	int width = 0;
	int prec = 0;
	char *org = dest;
	while(*fmt) {
		switch(*fmt) {
		case '%':

			fmt++;
			if(*fmt == '%')
			{
				*dest++ = *fmt;
			}
			else
			{
				if(isdigit(*fmt) || *fmt == '.') {
					width = atoi(fmt);
					while(isdigit(*fmt))
						fmt++;
					if(*fmt == '.')
						prec = atoi(++fmt);
					while(isdigit(*fmt))
						fmt++;
				}
				if(*fmt == 'l' || *fmt == 'h')
					fmt++;
				if(!width)
					width = prec;

				switch(*fmt) {
				case 'd':
				case 'i':
				case 'u':
					itoa_size(va_arg(vl, int), dest, 10, width, '0');
					break;
				case 'p':
				case 'X':
				case 'x':
					itoa_size(va_arg(vl, int), dest, 16, width, '0');
					break;
				case 'c':
					*dest++ = (char)va_arg(vl, int);
					*dest = 0;
					break;
				case 's':
					strcpy(dest, va_arg(vl, char*));
					break;
				default:
					fmt++;
					break;
				}
				dest += strlen(dest);
				break;
			}
			break;
		default:
			*dest++ = *fmt;
		}
		fmt++;
	}
	*dest = 0;
	return org-dest;
}

int sprintf(char *dest, char *fmt, ...)
{
	int rc;
	va_list vl;
	va_start(vl, fmt);

	rc = vsprintf(dest, fmt, vl);

	va_end(vl);
	return rc;
}


int pogo_printf(char *fmt, ...)
{
	char tmp[256];
	int rc;
	va_list vl;
	va_start(vl, fmt);

	rc = vsprintf(tmp, fmt, vl);
	pogo_write(FD_STDOUT, tmp, strlen(tmp));

	va_end(vl);
	return rc;
}

//void dprint(const char *sz);
void debug_print_gbaemu(const char *sz);
int pspeDebugWrite(char *, int);

int pogo_dprintf(char *fmt, ...)
{
	char tmp[256];
	int rc;
	va_list vl;
	va_start(vl, fmt);

	rc = vsprintf(tmp, fmt, vl);
#ifdef PSP
	pspeDebugWrite(tmp, strlen(tmp));
#elif (defined GBA)
	debug_print_gbaemu((const char *)tmp);
#endif
	//write(FD_STDERR, tmp, strlen(tmp));
	//dprint(tmp);
	va_end(vl);
	return rc;
}

int pogo_fprintf(POGOFILE *fp, char *fmt, ...)
{
	char tmp[256];
	int rc;
	va_list vl;
	va_start(vl, fmt);

	rc = pogo_vsprintf(tmp, fmt, vl);
	pogo_fwrite(tmp, 1, strlen(tmp), fp);

	va_end(vl);
	return rc;
}

int pogo_vfprintf(POGOFILE *fp, char *fmt, va_list vl)
{
	char tmp[256];
	int rc;

	rc = pogo_vsprintf(tmp, fmt, vl);
	pogo_fwrite(tmp, 1, strlen(tmp), fp);
	return rc;
}

